<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>XmlOutputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">XmlOutputArchive.java</span></div><h1>XmlOutputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.List;
import java.util.Stack;
import java.util.TreeMap;

/**
 *
 */
class XmlOutputArchive implements OutputArchive {

    private PrintStream stream;
    
<span class="nc" id="L35">    private int indent = 0;</span>
    
    private Stack&lt;String&gt; compoundStack;
    
    private void putIndent() {
<span class="nc" id="L40">        StringBuilder sb = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L41" title="All 2 branches missed.">        for (int idx = 0; idx &lt; indent; idx++) {</span>
<span class="nc" id="L42">            sb.append(&quot;  &quot;);</span>
        }
<span class="nc" id="L44">        stream.print(sb.toString());</span>
<span class="nc" id="L45">    }</span>
    
    private void addIndent() {
<span class="nc" id="L48">        indent++;</span>
<span class="nc" id="L49">    }</span>
    
    private void closeIndent() {
<span class="nc" id="L52">        indent--;</span>
<span class="nc" id="L53">    }</span>
    
    private void printBeginEnvelope(String tag) {
<span class="nc bnc" id="L56" title="All 2 branches missed.">        if (!compoundStack.empty()) {</span>
<span class="nc" id="L57">            String s = compoundStack.peek();</span>
<span class="nc bnc" id="L58" title="All 2 branches missed.">            if (&quot;struct&quot;.equals(s)) {</span>
<span class="nc" id="L59">                putIndent();</span>
<span class="nc" id="L60">                stream.print(&quot;&lt;member&gt;\n&quot;);</span>
<span class="nc" id="L61">                addIndent();</span>
<span class="nc" id="L62">                putIndent();</span>
<span class="nc" id="L63">                stream.print(&quot;&lt;name&gt;&quot;+tag+&quot;&lt;/name&gt;\n&quot;);</span>
<span class="nc" id="L64">                putIndent();</span>
<span class="nc" id="L65">                stream.print(&quot;&lt;value&gt;&quot;);</span>
<span class="nc bnc" id="L66" title="All 2 branches missed.">            } else if (&quot;vector&quot;.equals(s)) {</span>
<span class="nc" id="L67">                stream.print(&quot;&lt;value&gt;&quot;);</span>
<span class="nc bnc" id="L68" title="All 2 branches missed.">            } else if (&quot;map&quot;.equals(s)) {</span>
<span class="nc" id="L69">                stream.print(&quot;&lt;value&gt;&quot;);</span>
            }
<span class="nc" id="L71">        } else {</span>
<span class="nc" id="L72">            stream.print(&quot;&lt;value&gt;&quot;);</span>
        }
<span class="nc" id="L74">    }</span>
    
    private void printEndEnvelope(String tag) {
<span class="nc bnc" id="L77" title="All 2 branches missed.">        if (!compoundStack.empty()) {</span>
<span class="nc" id="L78">            String s = compoundStack.peek();</span>
<span class="nc bnc" id="L79" title="All 2 branches missed.">            if (&quot;struct&quot;.equals(s)) {</span>
<span class="nc" id="L80">                stream.print(&quot;&lt;/value&gt;\n&quot;);</span>
<span class="nc" id="L81">                closeIndent();</span>
<span class="nc" id="L82">                putIndent();</span>
<span class="nc" id="L83">                stream.print(&quot;&lt;/member&gt;\n&quot;);</span>
<span class="nc bnc" id="L84" title="All 2 branches missed.">            } else if (&quot;vector&quot;.equals(s)) {</span>
<span class="nc" id="L85">                stream.print(&quot;&lt;/value&gt;\n&quot;);</span>
<span class="nc bnc" id="L86" title="All 2 branches missed.">            } else if (&quot;map&quot;.equals(s)) {</span>
<span class="nc" id="L87">                stream.print(&quot;&lt;/value&gt;\n&quot;);</span>
            }
<span class="nc" id="L89">        } else {</span>
<span class="nc" id="L90">            stream.print(&quot;&lt;/value&gt;\n&quot;);</span>
        }
<span class="nc" id="L92">    }</span>
    
    private void insideVector(String tag) {
<span class="nc" id="L95">        printBeginEnvelope(tag);</span>
<span class="nc" id="L96">        compoundStack.push(&quot;vector&quot;);</span>
<span class="nc" id="L97">    }</span>
    
    private void outsideVector(String tag) throws IOException {
<span class="nc" id="L100">        String s = compoundStack.pop();</span>
<span class="nc bnc" id="L101" title="All 2 branches missed.">        if (!&quot;vector&quot;.equals(s)) {</span>
<span class="nc" id="L102">            throw new IOException(&quot;Error serializing vector.&quot;);</span>
        }
<span class="nc" id="L104">        printEndEnvelope(tag);</span>
<span class="nc" id="L105">    }</span>
    
    private void insideMap(String tag) {
<span class="nc" id="L108">        printBeginEnvelope(tag);</span>
<span class="nc" id="L109">        compoundStack.push(&quot;map&quot;);</span>
<span class="nc" id="L110">    }</span>
    
    private void outsideMap(String tag) throws IOException {
<span class="nc" id="L113">        String s = compoundStack.pop();</span>
<span class="nc bnc" id="L114" title="All 2 branches missed.">        if (!&quot;map&quot;.equals(s)) {</span>
<span class="nc" id="L115">            throw new IOException(&quot;Error serializing map.&quot;);</span>
        }
<span class="nc" id="L117">        printEndEnvelope(tag);</span>
<span class="nc" id="L118">    }</span>
    
    private void insideRecord(String tag) {
<span class="nc" id="L121">        printBeginEnvelope(tag);</span>
<span class="nc" id="L122">        compoundStack.push(&quot;struct&quot;);</span>
<span class="nc" id="L123">    }</span>
    
    private void outsideRecord(String tag) throws IOException {
<span class="nc" id="L126">        String s = compoundStack.pop();</span>
<span class="nc bnc" id="L127" title="All 2 branches missed.">        if (!&quot;struct&quot;.equals(s)) {</span>
<span class="nc" id="L128">            throw new IOException(&quot;Error serializing record.&quot;);</span>
        }
<span class="nc" id="L130">        printEndEnvelope(tag);</span>
<span class="nc" id="L131">    }</span>
    
    static XmlOutputArchive getArchive(OutputStream strm) {
<span class="nc" id="L134">        return new XmlOutputArchive(strm);</span>
    }
    
    /** Creates a new instance of XmlOutputArchive */
<span class="nc" id="L138">    public XmlOutputArchive(OutputStream out) {</span>
<span class="nc" id="L139">        stream = new PrintStream(out);</span>
<span class="nc" id="L140">        compoundStack = new Stack&lt;String&gt;();</span>
<span class="nc" id="L141">    }</span>
    
    public void writeByte(byte b, String tag) throws IOException {
<span class="nc" id="L144">        printBeginEnvelope(tag);</span>
<span class="nc" id="L145">        stream.print(&quot;&lt;ex:i1&gt;&quot;);</span>
<span class="nc" id="L146">        stream.print(Byte.toString(b));</span>
<span class="nc" id="L147">        stream.print(&quot;&lt;/ex:i1&gt;&quot;);</span>
<span class="nc" id="L148">        printEndEnvelope(tag);</span>
<span class="nc" id="L149">    }</span>
    
    public void writeBool(boolean b, String tag) throws IOException {
<span class="nc" id="L152">        printBeginEnvelope(tag);</span>
<span class="nc" id="L153">        stream.print(&quot;&lt;boolean&gt;&quot;);</span>
<span class="nc bnc" id="L154" title="All 2 branches missed.">        stream.print(b ? &quot;1&quot; : &quot;0&quot;);</span>
<span class="nc" id="L155">        stream.print(&quot;&lt;/boolean&gt;&quot;);</span>
<span class="nc" id="L156">        printEndEnvelope(tag);</span>
<span class="nc" id="L157">    }</span>
    
    public void writeInt(int i, String tag) throws IOException {
<span class="nc" id="L160">        printBeginEnvelope(tag);</span>
<span class="nc" id="L161">        stream.print(&quot;&lt;i4&gt;&quot;);</span>
<span class="nc" id="L162">        stream.print(Integer.toString(i));</span>
<span class="nc" id="L163">        stream.print(&quot;&lt;/i4&gt;&quot;);</span>
<span class="nc" id="L164">        printEndEnvelope(tag);</span>
<span class="nc" id="L165">    }</span>
    
    public void writeLong(long l, String tag) throws IOException {
<span class="nc" id="L168">        printBeginEnvelope(tag);</span>
<span class="nc" id="L169">        stream.print(&quot;&lt;ex:i8&gt;&quot;);</span>
<span class="nc" id="L170">        stream.print(Long.toString(l));</span>
<span class="nc" id="L171">        stream.print(&quot;&lt;/ex:i8&gt;&quot;);</span>
<span class="nc" id="L172">        printEndEnvelope(tag);</span>
<span class="nc" id="L173">    }</span>
    
    public void writeFloat(float f, String tag) throws IOException {
<span class="nc" id="L176">        printBeginEnvelope(tag);</span>
<span class="nc" id="L177">        stream.print(&quot;&lt;ex:float&gt;&quot;);</span>
<span class="nc" id="L178">        stream.print(Float.toString(f));</span>
<span class="nc" id="L179">        stream.print(&quot;&lt;/ex:float&gt;&quot;);</span>
<span class="nc" id="L180">        printEndEnvelope(tag);</span>
<span class="nc" id="L181">    }</span>
    
    public void writeDouble(double d, String tag) throws IOException {
<span class="nc" id="L184">        printBeginEnvelope(tag);</span>
<span class="nc" id="L185">        stream.print(&quot;&lt;double&gt;&quot;);</span>
<span class="nc" id="L186">        stream.print(Double.toString(d));</span>
<span class="nc" id="L187">        stream.print(&quot;&lt;/double&gt;&quot;);</span>
<span class="nc" id="L188">        printEndEnvelope(tag);</span>
<span class="nc" id="L189">    }</span>
    
    public void writeString(String s, String tag) throws IOException {
<span class="nc" id="L192">        printBeginEnvelope(tag);</span>
<span class="nc" id="L193">        stream.print(&quot;&lt;string&gt;&quot;);</span>
<span class="nc" id="L194">        stream.print(Utils.toXMLString(s));</span>
<span class="nc" id="L195">        stream.print(&quot;&lt;/string&gt;&quot;);</span>
<span class="nc" id="L196">        printEndEnvelope(tag);</span>
<span class="nc" id="L197">    }</span>
    
    public void writeBuffer(byte buf[], String tag)
    throws IOException {
<span class="nc" id="L201">        printBeginEnvelope(tag);</span>
<span class="nc" id="L202">        stream.print(&quot;&lt;string&gt;&quot;);</span>
<span class="nc" id="L203">        stream.print(Utils.toXMLBuffer(buf));</span>
<span class="nc" id="L204">        stream.print(&quot;&lt;/string&gt;&quot;);</span>
<span class="nc" id="L205">        printEndEnvelope(tag);</span>
<span class="nc" id="L206">    }</span>
    
    public void writeRecord(Record r, String tag) throws IOException {
<span class="nc" id="L209">        r.serialize(this, tag);</span>
<span class="nc" id="L210">    }</span>
    
    public void startRecord(Record r, String tag) throws IOException {
<span class="nc" id="L213">        insideRecord(tag);</span>
<span class="nc" id="L214">        stream.print(&quot;&lt;struct&gt;\n&quot;);</span>
<span class="nc" id="L215">        addIndent();</span>
<span class="nc" id="L216">    }</span>
    
    public void endRecord(Record r, String tag) throws IOException {
<span class="nc" id="L219">        closeIndent();</span>
<span class="nc" id="L220">        putIndent();</span>
<span class="nc" id="L221">        stream.print(&quot;&lt;/struct&gt;&quot;);</span>
<span class="nc" id="L222">        outsideRecord(tag);</span>
<span class="nc" id="L223">    }</span>
    
    public void startVector(List v, String tag) throws IOException {
<span class="nc" id="L226">        insideVector(tag);</span>
<span class="nc" id="L227">        stream.print(&quot;&lt;array&gt;\n&quot;);</span>
<span class="nc" id="L228">        addIndent();</span>
<span class="nc" id="L229">    }</span>
    
    public void endVector(List v, String tag) throws IOException {
<span class="nc" id="L232">        closeIndent();</span>
<span class="nc" id="L233">        putIndent();</span>
<span class="nc" id="L234">        stream.print(&quot;&lt;/array&gt;&quot;);</span>
<span class="nc" id="L235">        outsideVector(tag);</span>
<span class="nc" id="L236">    }</span>
    
    public void startMap(TreeMap v, String tag) throws IOException {
<span class="nc" id="L239">        insideMap(tag);</span>
<span class="nc" id="L240">        stream.print(&quot;&lt;array&gt;\n&quot;);</span>
<span class="nc" id="L241">        addIndent();</span>
<span class="nc" id="L242">    }</span>
    
    public void endMap(TreeMap v, String tag) throws IOException {
<span class="nc" id="L245">        closeIndent();</span>
<span class="nc" id="L246">        putIndent();</span>
<span class="nc" id="L247">        stream.print(&quot;&lt;/array&gt;&quot;);</span>
<span class="nc" id="L248">        outsideMap(tag);</span>
<span class="nc" id="L249">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>